--- channels/chan_sip.c	2007-10-10 16:42:00.000000000 +0200
+++ channels/chan_sip.c	2007-10-18 19:39:31.000000000 +0200
@@ -8877,12 +8877,18 @@
 	
 	if ((ptr = strchr(refer_to, '@'))) {	/* Separate domain */
 		char *urioption;
-
+		char *domain;
 		*ptr++ = '\0';
-		if ((urioption = strchr(ptr, ';')))
+
+		if ((urioption = strchr(ptr, ';'))) /* Separate urioptions */
 			*urioption++ = '\0';
+		
+		domain = ptr;
+		if ((ptr = strchr(domain, ':')))	/* Remove :port */
+			*ptr = '\0';
+		
 		/* Save the domain for the dial plan */
-		ast_copy_string(referdata->refer_to_domain, ptr, sizeof(referdata->refer_to_domain));
+		ast_copy_string(referdata->refer_to_domain, domain, sizeof(referdata->refer_to_domain));
 		if (urioption)
 			ast_copy_string(referdata->refer_to_urioption, urioption, sizeof(referdata->refer_to_urioption));
 	}
@@ -14162,8 +14168,15 @@
 	} else if (AST_LIST_EMPTY(&domain_list)) {
 		/* This PBX don't bother with SIP domains, so all transfers are local */
 		p->refer->localtransfer = 1;
-	} else
+	} 		
+	
+	/* If we support SIP domains we need to check the domain */
+	if (!allow_external_domains && check_sip_domain(p->refer->refer_to_domain, NULL, sizeof(p->refer->refer_to_domain))) {
+		p->refer->localtransfer = 1;
+		
 		if (sipdebug && option_debug > 2)
+			ast_log(LOG_DEBUG, "This SIP transfer is to local domain %s)\n", p->refer->refer_to_domain);
+	} else if (sipdebug && option_debug > 2)
 			ast_log(LOG_DEBUG, "This SIP transfer is to a remote SIP extension (remote domain %s)\n", p->refer->refer_to_domain);
 	
 	/* Is this a repeat of a current request? Ignore it */
